#ifndef __PD443X_H_
#define __PD443X_H_

class PD443X {
private:
  uint8_t displayBuffer[4];
  uint8_t nRST, nCE0, nWR;
  uint8_t pA2, pA1, pA0;
  uint8_t pD7, pD6, pD5, pD4, pD3, pD2, pD1, pD0;
  
public:
  PD443X(const uint8_t nRST, const uint8_t nCE0, const uint8_t nWR,
         const uint8_t pA2, const uint8_t pA1, const uint8_t pA0,
         const uint8_t pD7, const uint8_t pD6, const uint8_t pD5,
         const uint8_t pD4, const uint8_t pD3, const uint8_t pD2,
         const uint8_t pD1, const uint8_t pD0);
  ~PD443X();
  void initialize();
  void initialize(const uint8_t br);
  void clear();
  void setBrightness(const uint8_t br);
  void writeChar(const int8_t pos, const uint8_t c);
  void writeString(const char* str, const int8_t offset, const int8_t length=4);
  void scrollString(const char* str, const uint16_t ms);
  void scrollLeft(const uint8_t c);
  void scrollRight(const uint8_t c);
  void writeNumber(const int8_t pos, const uint8_t n);
  void writeValue(const int16_t val, const int8_t offset,
                  const uint8_t digits, const bool zs=true);

private:
  inline void setCommandMode();
  inline void setAsciiMode();
  inline void setAddress(uint8_t a);
  inline void setByte(uint8_t b);
};

#endif  // __PD443X_H_

